"""Puglin subscriber for `JLCPCB_main.py` file.
"""

import wx
import pcbnew
import os

from JLCPCB_main import create_pcba


class ActionJLCPCB(pcbnew.ActionPlugin):
    """Initiale Plugin
    """

    def __init__(self):
        super().__init__()
        self.name = "Export PCBA Files"
        self.category = "PCBA"
        self.description = "Create BOM and CPL files for JLCPCBs PCBA Service"
        self.show_toolbar_button = True
        self.version = '1.0'
        self.icon_file_name = os.path.join(os.path.dirname(__file__), 'img\jlcpcb_28x28.png')

    def Run(self):
        """Initiale Start
        """
        print("----Starting plugin JLCPCB Action Plugin---")
        try:
            create_pcba()
            board = pcbnew.GetBoard()
            board_file = board.GetFileName()
            project_path = os.path.dirname(board_file)
            projet_name = os.path.splitext(os.path.basename(board_file))[0]
            file_1 = os.path.join(project_path, projet_name) + 'JLCPCB_CPL_file.csv'
            file_2 = os.path.join(project_path, projet_name) + 'JLCPCB_CPL_file.csv'
            wx.MessageDialog(self, any(), file_1 + '"\r\n' + file_2, "All Done", "OK").ShowModal()

        except Exception as e:
            import traceback

            plugin_dir = os.path.dirname(os.path.realpath(__file__))
            log_file = os.path.join(plugin_dir, 'JLCPCB_run.log')
            tb = ''.join(traceback.format_exception(None, e, e.__traceback__))

            with open(log_file, 'w') as f:
                f.write(tb)

            wx.MessageDialog(None, "Failed, check logs").ShowModal()
